#define _TSMPIPE_VERSION "1.5.2"

#define ACTION_INFO 1
#define ACTION_CREATE 2
#define ACTION_EXTRACT 3
#define ACTION_DELETE 4
#define ACTION_LIST 5

// If you want to use MD5/SHA1 calculations as the data goes in here, ensure this is defined.
#define USE_DIGEST

typedef int (*tsm_query_callback)(dsmQueryType, DataBlk *, void *);

struct matchone_cb_data { int numfound; dsStruct64_t objId; dsUint32_t copyGroup; };

extern void tsm_printerr   (dsUint32_t dsmHandle, dsInt16_t rc, char *str);
extern void debugLog(int level, _IO_FILE *output, char *message, int die);

extern dsmDate dsmStrToDate(char *s);
extern dsmObjName dsmNameToObjname(char *fsname, char *filename);
extern dsInt16_t tsm_queryfile(dsUint32_t sesshandle, dsmQueryType qType, tsm_query_callback usercb, void *userdata, qryArchiveData qaData, qryBackupData qbData);
extern dsUint32_t tsm_initsess(char *options);
extern dsBool_t compressEnabled;

extern int tsm_deletefile (dsUint32_t dsmHandle, dsmQueryType qType, qryArchiveData qaData, qryBackupData qbData);
extern int tsm_listfile   (dsUint32_t dsmHandle, dsmQueryType qType, qryArchiveData qaData, qryBackupData qbData);
extern int tsm_restorefile(dsUint32_t dsmHandle, dsmQueryType qType, qryArchiveData qaData, qryBackupData qbData);
#ifdef USE_DIGEST
extern int tsm_sendfile   (dsUint32_t dsmHandle, char *fsname, char *filename, long long length, char *description, dsmSendType sendtype, char *digest);
#else
extern int tsm_sendfile   (dsUint32_t dsmHandle, char *fsname, char *filename, long long length, char *description, dsmSendType sendtype);
#endif
extern int tsm_sessioninfo(dsUint32_t dsmHandle);

extern char *dsmDateToStr(dsmDate date);
extern char *dsmObjnameToStr(dsmObjName objName);

extern double dsmSizeToNum(dsStruct64_t dsStruct64);
